/**
 * Copyright 2016 Google Inc. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// This generated service worker JavaScript will precache your site's resources.
// The code needs to be saved in a .js file at the top-level of your site, and registered
// from your pages in order to be used. See
// https://github.com/googlechrome/sw-precache/blob/master/demo/app/js/service-worker-registration.js
// for an example of how you can register this script and handle various service worker events.

/* eslint-env worker, serviceworker */
/* eslint-disable indent, no-unused-vars, no-multiple-empty-lines, max-nested-callbacks, space-before-function-paren, quotes, comma-spacing */
'use strict';

var precacheConfig = [["addplugin.html","0849ac514f36f5d7d5ac2a5fb4dc992a"],["appservices.html","af039186189b5967c588095f0c848b35"],["bower_components/Sortable/Sortable.html","c73cafa7115d30a4c8a6f9f5f0c53a28"],["bower_components/Sortable/Sortable.min.js","4e06bd835ced323b805619070fadae29"],["bower_components/Sortable/index.html","d219df1b5d5441fb3ff2d07a5b32b014"],["bower_components/Sortable/jquery.binding.js","877e39ecd07d5848ea7d98023cd5d467"],["bower_components/Sortable/knockout-sortable.js","0c8e058db9f36144594213c06eb2d2f2"],["bower_components/Sortable/ng-sortable.js","801ca32000d8c7edc5d214cebcb3c17f"],["bower_components/Sortable/react-sortable-mixin.js","8ecd30fb9a31dd17a3ed705d463bf33e"],["bower_components/Swiper/LICENSE","5a0f81f360765c309d5b143e43a35226"],["bower_components/Swiper/dist/css/swiper.min.css","3a731d5a64a9cf9052fcdf4bd5af621e"],["bower_components/Swiper/dist/js/swiper.min.js","05b46655d357eb39a4a99fbe79a8f7e9"],["bower_components/Swiper/gulpfile.js","68e9917f3da86138970e50b829dcd2d2"],["bower_components/Swiper/package.js","4016a80bd0a7b8c05a0c487d91bb183e"],["bower_components/alameda/LICENSE","8586b07a63bd1f45854d891bfada80a6"],["bower_components/alameda/alameda.js","62d9930c719e5c4ff1af2515fdea918b"],["bower_components/cryptojslib/components/core-min.js","556fcbaf96680b77cc9d773133cb4ba6"],["bower_components/cryptojslib/components/md5-min.js","08eeb65c9dea30aba872de47915032ce"],["bower_components/cryptojslib/components/sha1-min.js","0e46b4528efbb70c954ec56e70f9e75d"],["bower_components/document-register-element/basic.html","898bcab6e1035312b7309610cf68e91c"],["bower_components/document-register-element/build/document-register-element.js","12d3900aff5f7932e7cf5f7a6ee59952"],["bower_components/document-register-element/testrunner.js","bcc23413bf04c5645c292dcd8b5759f0"],["bower_components/emby-apiclient/apiclient.js","a38e9095206331a257b6837e86415c63"],["bower_components/emby-apiclient/apiclientex.js","30afac2dfdcdbe2db708226e0d8af972"],["bower_components/emby-apiclient/appstorage-cache.js","4854257a42c94c14b1e10429bc9c9f8f"],["bower_components/emby-apiclient/appstorage-localstorage.js","4b9a16c28d60c551198cbc5dfd34f0e2"],["bower_components/emby-apiclient/appstorage-memory.js","71bba45c59c89bdd4688b9f2d6c30edc"],["bower_components/emby-apiclient/cameraroll.js","a449b52cd4cd99490aa15406876ee82a"],["bower_components/emby-apiclient/connectionmanager.js","febf3bd70d54cd983acc2bb5a5fb3cba"],["bower_components/emby-apiclient/credentials.js","bffc3fe55ed82ce5315c1a6e67201143"],["bower_components/emby-apiclient/events.js","271fbc6fec840abba37c4a7470847ea9"],["bower_components/emby-apiclient/fileupload.js","e335a131eea1cdb1a825486f72e5fa85"],["bower_components/emby-apiclient/localassetmanager.js","bf0140a7aace1ae7a77e65c0e52f9ea0"],["bower_components/emby-apiclient/serverdiscovery-chrome.js","250c100c4de205ca680de88d6d2fb3e8"],["bower_components/emby-apiclient/serverdiscovery-winjs.js","b0070afe8bcf983f447506ff2db9cb0a"],["bower_components/emby-apiclient/serverdiscovery.js","de70018cf135632cd5203fad7592bbbf"],["bower_components/emby-apiclient/sync/contentuploader.js","5c10171ebbf2dd93201129b3ca487068"],["bower_components/emby-apiclient/sync/filerepository.js","613562037c21b808ebd45db6b4a825c4"],["bower_components/emby-apiclient/sync/itemrepository.js","ae79cd6e2a1e5e4eb81ef84a2918c5b4"],["bower_components/emby-apiclient/sync/localsync.js","f82c26b44ebc4a01ad528078069f3eea"],["bower_components/emby-apiclient/sync/mediasync.js","aa11612c5c32823160057c618fbb9788"],["bower_components/emby-apiclient/sync/multiserversync.js","4c3adb6c5730a5b75dd113d9885d8dd1"],["bower_components/emby-apiclient/sync/serversync.js","511105ca967cf607015d8fe4b79410d4"],["bower_components/emby-apiclient/sync/transfermanager.js","1d120bba2ff04b0aa05bd295b8b9a3fe"],["bower_components/emby-apiclient/sync/useractionrepository.js","3bf62302bf254a44e31b00732e184729"],["bower_components/emby-apiclient/wakeonlan.js","0710127b23ad75e76f028c980f504996"],["bower_components/emby-webcomponents/actionsheet/actionsheet.css","32a81a380ebd794df6ca856b19cc96bd"],["bower_components/emby-webcomponents/actionsheet/actionsheet.js","4bb4a62588b8162f4126448947d29fb3"],["bower_components/emby-webcomponents/alert/alert.js","bd63b99a4c2fcd8aaeb65463f6d38f8e"],["bower_components/emby-webcomponents/alert/nativealert.js","cc84d052de86a62aae62cb33027d0563"],["bower_components/emby-webcomponents/alphanumericshortcuts/alphanumericshortcuts.js","1f19d690c03708d6325005377895cabd"],["bower_components/emby-webcomponents/alphapicker/alphapicker.js","830f08b9ba40f6a34068705bb77b3118"],["bower_components/emby-webcomponents/alphapicker/style.css","79021b10c335136c19e4d3099415d3fe"],["bower_components/emby-webcomponents/appfooter/appfooter.css","647fb8ba00e7daddbb4207d527ad2457"],["bower_components/emby-webcomponents/appfooter/appfooter.js","266ef50be74fbdda354fe4ef8c3eb9a8"],["bower_components/emby-webcomponents/appsettings.js","9e0e937e0345f8ddac10ac06d0c8419c"],["bower_components/emby-webcomponents/backdrop/backdrop.js","0bda85cec731b15fcc77c365a6d5e789"],["bower_components/emby-webcomponents/backdrop/style.css","872c223a0b740a1ae5a99a14361b299b"],["bower_components/emby-webcomponents/browser.js","08c26dd5d2ef9032f4083b069141dd81"],["bower_components/emby-webcomponents/browserdeviceprofile.js","13ef15db98c1cad7402a2c164a6271d3"],["bower_components/emby-webcomponents/cardbuilder/card.css","20d50472306357bc32c9226367f6d046"],["bower_components/emby-webcomponents/cardbuilder/cardbuilder.js","efbcdd4075dedcfc9b47f50f5aaeaa4c"],["bower_components/emby-webcomponents/cardbuilder/chaptercardbuilder.js","ad2fb2b22619a7c6a459fe44be0d4c53"],["bower_components/emby-webcomponents/cardbuilder/peoplecardbuilder.js","a6cf858bdfc250f42a0f849a17b21aef"],["bower_components/emby-webcomponents/cardbuilder/roundcard.css","71480f4cbd7319372d79d681c4a40396"],["bower_components/emby-webcomponents/chromecast/chromecasthelpers.js","39bcd5b59e9244ef36362ae400520184"],["bower_components/emby-webcomponents/chromecast/chromecastplayer.js","14a0b7cbbc9148bc9b9d2d0d28a298e9"],["bower_components/emby-webcomponents/clearbutton.css","4a3bf431073ea6ad78fdf57c2ce88e7f"],["bower_components/emby-webcomponents/collectioneditor/collectioneditor.js","068f60dc60d9f96ab1f577fd52e409a3"],["bower_components/emby-webcomponents/confirm/confirm.js","90079853307ebbf4ada4e56a9a53ff44"],["bower_components/emby-webcomponents/confirm/nativeconfirm.js","7e8f58b39e3df37a10ff40ef84f785e0"],["bower_components/emby-webcomponents/datetime.js","96a6d48750935ed1c590c377d99569ab"],["bower_components/emby-webcomponents/deletehelper.js","50b402158d74e1cb0d4689832fea054c"],["bower_components/emby-webcomponents/dialog/dialog.js","2a68791f7d16fe47b5443b98d9ca13df"],["bower_components/emby-webcomponents/dialog/dialog.template.html","c04a9bc2c06de4380365bfce3039b4ca"],["bower_components/emby-webcomponents/dialoghelper/dialoghelper.css","aaea1fdca9ac7e8de8ac03eb04405385"],["bower_components/emby-webcomponents/dialoghelper/dialoghelper.js","0b95080f61ee5e913517430e0b73e884"],["bower_components/emby-webcomponents/displaysettings/displaysettings.js","b8dd39de459984c3f9bd887c80043773"],["bower_components/emby-webcomponents/displaysettings/displaysettings.template.html","ea969a52cb11e02d8fcfb253d50d5fc0"],["bower_components/emby-webcomponents/dom.js","1a59496e8ecc6e8b930641ec3430a6ce"],["bower_components/emby-webcomponents/emby-button/emby-button.css","9d9970e8d6cd8f61fd3041b92bd8a972"],["bower_components/emby-webcomponents/emby-button/emby-button.js","45a87e7371afe234d70439502ed48fbb"],["bower_components/emby-webcomponents/emby-button/paper-icon-button-light.js","fafe8277e75c0ec9f8e5d409aa7e3b98"],["bower_components/emby-webcomponents/emby-checkbox/emby-checkbox.css","9a93a81b7f9b00701a8728344a1e1a2f"],["bower_components/emby-webcomponents/emby-checkbox/emby-checkbox.js","11ceaec449749c622cb502c55a395b43"],["bower_components/emby-webcomponents/emby-collapse/emby-collapse.css","d77e9ba3589bdc1b603a11390e7ce885"],["bower_components/emby-webcomponents/emby-collapse/emby-collapse.js","f41fc081d9bf020874d462c20c4c348b"],["bower_components/emby-webcomponents/emby-connect/connecthelper.js","eb4eae92f3698d0f803acefa6f97198e"],["bower_components/emby-webcomponents/emby-input/emby-input.css","511edfac9d894977b7c0c0e75c4a17fe"],["bower_components/emby-webcomponents/emby-input/emby-input.js","2082075395c8bc8f6671b0a3e49a92aa"],["bower_components/emby-webcomponents/emby-itemrefreshindicator/emby-itemrefreshindicator.js","dce1709cd7ca821e2886248df39fbba0"],["bower_components/emby-webcomponents/emby-itemscontainer/emby-itemscontainer.js","cc76c7249b3171e39d9c9bdc26c0fb9e"],["bower_components/emby-webcomponents/emby-progressring/emby-progressring.css","f37c392e4efcab63f0ed61faa793da08"],["bower_components/emby-webcomponents/emby-progressring/emby-progressring.js","317f8d449c93de3323020982c8dc2f8e"],["bower_components/emby-webcomponents/emby-progressring/emby-progressring.template.html","c4bf0180d1bc95a1eb85833da23abfa8"],["bower_components/emby-webcomponents/emby-radio/emby-radio.css","724f9a13c65799cc3abd6f7f301f372e"],["bower_components/emby-webcomponents/emby-radio/emby-radio.js","e6ae0880efc4ba200627350876684968"],["bower_components/emby-webcomponents/emby-scrollbuttons/emby-scrollbuttons.css","d0c0b76aeadcae1b04bafbc2b40b2a94"],["bower_components/emby-webcomponents/emby-scrollbuttons/emby-scrollbuttons.js","573b06b41ace0933f1972767f4ac3eab"],["bower_components/emby-webcomponents/emby-scroller/emby-scroller.js","e981ac3fcaf4ca459c075232c5f90fec"],["bower_components/emby-webcomponents/emby-select/emby-select.css","a927b269a84f48c4faac631a747c4c2d"],["bower_components/emby-webcomponents/emby-select/emby-select.js","33e3e02d342819ee385c81d89cbb0605"],["bower_components/emby-webcomponents/emby-slider/emby-slider.css","6ec5940ffd4d5d1dde51c6758d610f38"],["bower_components/emby-webcomponents/emby-slider/emby-slider.js","aca3b826b8f069cffd0cff978e14f33e"],["bower_components/emby-webcomponents/emby-tabs/emby-tabs.css","5645d98edf1c1ad71d6b5e56744c0bb8"],["bower_components/emby-webcomponents/emby-tabs/emby-tabs.js","d081a3341aa30a525b5a380fb9831a69"],["bower_components/emby-webcomponents/emby-textarea/emby-textarea.css","0449c325c64f829d2bb93360b847c537"],["bower_components/emby-webcomponents/emby-textarea/emby-textarea.js","99a31829cf1ec4ccde452c84e883a953"],["bower_components/emby-webcomponents/fetchhelper.js","25d951a43a5b1e3465778f7807592f57"],["bower_components/emby-webcomponents/filedownloader.js","fad41db687182d0c82c0116eedd8a7f0"],["bower_components/emby-webcomponents/filesystem.js","97dbb0ca7c67e0a878cae1e9c8a9acc7"],["bower_components/emby-webcomponents/filtermenu/filtermenu.js","2eaf940fba6984605014cd2db32fecb4"],["bower_components/emby-webcomponents/filtermenu/filtermenu.template.html","f593b3d79802217df8ccab9be6ad1f04"],["bower_components/emby-webcomponents/flexstyles.css","297961c52201b7b2a7ae031abc7bb7bc"],["bower_components/emby-webcomponents/flvjs/flv.min.js","4626b50fb28276fd10b6fad501ad8279"],["bower_components/emby-webcomponents/focusmanager.js","1b9cdc63ee7458a360d5dcf5a62e61ca"],["bower_components/emby-webcomponents/fonts/fonts.css","f704f9149159d6849f53abd5f2a535bd"],["bower_components/emby-webcomponents/fonts/fonts.sized.css","ee8a04bba5bffd45922669727c653d20"],["bower_components/emby-webcomponents/fonts/material-icons/2fcryfnatjcs6g4u3t-y5ewrjpiaoeww8aihgqwrjao.woff","a7e6052bb5ecfad6670f6c214503d336"],["bower_components/emby-webcomponents/fonts/material-icons/2fcryfnatjcs6g4u3t-y5zjzjt5fdej140u2djyc3my.woff2","9fb20fb9a41e500a1a30ba2372fb5030"],["bower_components/emby-webcomponents/fonts/material-icons/style.css","7cae80d159f98421411d19858d350b9c"],["bower_components/emby-webcomponents/formdialog.css","d2d61aef1599203a73e4a699bcc399a9"],["bower_components/emby-webcomponents/fullscreen/fullscreen-doubleclick.js","ec5246181916be93987c3393b864e273"],["bower_components/emby-webcomponents/fullscreen/fullscreenmanager.js","555eb12c674fbffd3861b4ceedbd215a"],["bower_components/emby-webcomponents/globalize.js","65a6b04fbd49bd2f6e31aa61390267bf"],["bower_components/emby-webcomponents/guide/guide-settings.js","07aaf490db057ee7f6db243fccf8df31"],["bower_components/emby-webcomponents/guide/guide-settings.template.html","980b733989b32c0aaef174d73936a7e1"],["bower_components/emby-webcomponents/guide/guide.css","443db2f24c5240d5092eead025fa2926"],["bower_components/emby-webcomponents/guide/guide.js","a733de38fcee820704cd76d0597d88c4"],["bower_components/emby-webcomponents/guide/programs.css","66d77baf544986c0e903bec538009788"],["bower_components/emby-webcomponents/guide/tvguide.template.html","360b0bfb95fc85a09e7e21d7693a55bf"],["bower_components/emby-webcomponents/headroom/headroom.css","d4440debd99edc76ffea611df4f6d7d9"],["bower_components/emby-webcomponents/headroom/headroom.js","dde6cc009b409ca08d6e3b52b6fb02e6"],["bower_components/emby-webcomponents/homescreensettings/homescreensettings.js","f9a263786a9427db6076f122eb77231c"],["bower_components/emby-webcomponents/homescreensettings/homescreensettings.template.html","c0ce045957c90c3de677c27bcfb540b8"],["bower_components/emby-webcomponents/homescreensettings/homescreensettingsdialog.js","add3d5e1b8c92eed63d24a5d08ae9693"],["bower_components/emby-webcomponents/homescreensettings/homescreensettingsdialog.template.html","1d2bc0dffd673d032d1454397a001a83"],["bower_components/emby-webcomponents/homesections/homesections.css","83e9b7cba09043c9ca3ba78951533ca0"],["bower_components/emby-webcomponents/homesections/homesections.js","a0a4f085152f6d9620bedcc5ce0bdce4"],["bower_components/emby-webcomponents/htmlaudioplayer/plugin.js","2ec5f5adc66c6f0e83a6805c7b59d3a7"],["bower_components/emby-webcomponents/htmlvideoplayer/htmlmediahelper.js","ef2739c68df9799fdbb50c1188ca8e5b"],["bower_components/emby-webcomponents/htmlvideoplayer/plugin.js","fc922abe41189b7175643dab2e23071f"],["bower_components/emby-webcomponents/htmlvideoplayer/style.css","8f5bf8bcbebf138994bcd0efc5c8c128"],["bower_components/emby-webcomponents/imagedownloader/imagedownloader.js","cea2b66523c3994beeb16342bf6a33b4"],["bower_components/emby-webcomponents/imagedownloader/imagedownloader.template.html","e50e801daa9ccd2d75c8bb74593c75b8"],["bower_components/emby-webcomponents/imageeditor/imageeditor.css","c9d6d9d551e7c43acebbb3cc6a1c922d"],["bower_components/emby-webcomponents/imageeditor/imageeditor.js","f18c085a4c8a6779918aadfbd2a98444"],["bower_components/emby-webcomponents/imageeditor/imageeditor.template.html","e759a3e6bd6e93263d27f391a8ddd13f"],["bower_components/emby-webcomponents/images/basicimagefetcher.js","7db6bab4bfe19960cd0b196a4a4cf9cb"],["bower_components/emby-webcomponents/images/imagehelper.js","69b6c19180898f4222384cbd44c330f5"],["bower_components/emby-webcomponents/images/style.css","97fd5682b2fdee83ba0dd2b11d3a0047"],["bower_components/emby-webcomponents/imageuploader/imageuploader.js","6f456b4776f8ad954621e61f1bbf63e0"],["bower_components/emby-webcomponents/imageuploader/imageuploader.template.html","b04ab030db4b0110021b5b8627fc0187"],["bower_components/emby-webcomponents/imageuploader/style.css","716f6f1e22b475321b545b5fa4b8faa5"],["bower_components/emby-webcomponents/indicators/indicators.css","4e05ebed55c4935729f31d430bfa4129"],["bower_components/emby-webcomponents/indicators/indicators.js","862b4a84ad15125dc7711811958f0ffb"],["bower_components/emby-webcomponents/input/api.js","9832177ad4a7f64c0e72197326c0ebcb"],["bower_components/emby-webcomponents/input/gamepadtokey.js","de609a72151e7bfe7744185a1fffb6f9"],["bower_components/emby-webcomponents/input/mouse.js","af148ee50e7b19ddd0e6a6140353cba5"],["bower_components/emby-webcomponents/inputmanager.js","7f95fc8a86dbcd767ef5bab5427f10a1"],["bower_components/emby-webcomponents/itemcontextmenu.js","71e73f87d1eada78c20e4bcabd898e47"],["bower_components/emby-webcomponents/itemhelper.js","7cf5181a0e1ef35da53144a9473ee23e"],["bower_components/emby-webcomponents/itemhovermenu/itemhovermenu.css","ac3142b196819c9fdabb634f1dc83b7f"],["bower_components/emby-webcomponents/itemhovermenu/itemhovermenu.js","b68fe46c1df4530433080f91d17864a6"],["bower_components/emby-webcomponents/itemidentifier/itemidentifier.js","bc5ece5f5fa29fcfc218aec7f376f047"],["bower_components/emby-webcomponents/itemidentifier/itemidentifier.template.html","8666f3cab5db8dc6af4a39a2cdcf8ec2"],["bower_components/emby-webcomponents/layoutmanager.js","182c4bd157620c93eb48c2c04049dcf1"],["bower_components/emby-webcomponents/lazyloader/lazyedgehack.css","3e575bbddffb5a61ad0171fcba27fd3e"],["bower_components/emby-webcomponents/lazyloader/lazyloader-intersectionobserver.js","23ec7e9452d2bb3db0ff4d890e79ce9f"],["bower_components/emby-webcomponents/lazyloader/lazyloader-scroll.js","2e3b4d51e32dc27e5c46671c9f7768fa"],["bower_components/emby-webcomponents/listview/listview.css","77cff2efa5c3209e077b8b61d7956a34"],["bower_components/emby-webcomponents/listview/listview.js","63f6208a26008113f5f981a5938f3ad0"],["bower_components/emby-webcomponents/loading/loader2.gif","bb01ab84dfdb6aeceb578d37f5d388eb"],["bower_components/emby-webcomponents/loading/loading-legacy.css","c0925f18a10a5b1b1cf2a42954ae5cc2"],["bower_components/emby-webcomponents/loading/loading-legacy.js","9d85177ff15ffebc0a5f740c5b57afe7"],["bower_components/emby-webcomponents/loading/loading-lite.css","4b22e26ce80cca78969958c673077c82"],["bower_components/emby-webcomponents/loading/loading-lite.js","6510064d4503ece5af96de01c3e3f110"],["bower_components/emby-webcomponents/maintabsmanager.js","f80c53bb14d56c9f310770ca1edeb8d6"],["bower_components/emby-webcomponents/mediainfo/fresh.png","3bf36d75b08def63990515f1150c3d42"],["bower_components/emby-webcomponents/mediainfo/mediainfo.css","f8c7e66941cfb815b629f1a4264a578c"],["bower_components/emby-webcomponents/mediainfo/mediainfo.js","1d98742dc51e08768a6de7ece0d83ca3"],["bower_components/emby-webcomponents/mediainfo/rotten.png","413ef48111187bf3f84abf73a89173f2"],["bower_components/emby-webcomponents/metadataeditor/metadataeditor.js","5f76028f3a7ca8a92dcb2f4b8516501d"],["bower_components/emby-webcomponents/metadataeditor/metadataeditor.template.html","71e6599f1c0f20b4ef4a7c3853d9ab84"],["bower_components/emby-webcomponents/metadataeditor/personeditor.js","f506e3da87e8522dd0ca1725bbb856b8"],["bower_components/emby-webcomponents/metadataeditor/personeditor.template.html","0062ac8e60160a07a117d8109e035440"],["bower_components/emby-webcomponents/multidownload.js","64ae9314ec7c8d1ddcfe28791c89897d"],["bower_components/emby-webcomponents/multiselect/multiselect.css","a76f14b94c2c0cad160b363f9c3d8c73"],["bower_components/emby-webcomponents/multiselect/multiselect.js","82214bfb29727591a2b49482426abb60"],["bower_components/emby-webcomponents/native-promise-only/lib/npo.src.js","c4d349c1a6aab01ef5361723a02e3618"],["bower_components/emby-webcomponents/native-promise-only/test_adapter.js","9b26cff9b47f0209e70d3130a1150fa6"],["bower_components/emby-webcomponents/notifications/badge.png","568dc42ec4e0304324f7afeef814cd5e"],["bower_components/emby-webcomponents/notifications/notificationicon.png","568dc42ec4e0304324f7afeef814cd5e"],["bower_components/emby-webcomponents/notifications/notifications.js","4d7d77beab47820f0cea127d831481f4"],["bower_components/emby-webcomponents/nowplayingbar/nowplayingbar.css","cfae3806581b01bc6fdf09a3604e8451"],["bower_components/emby-webcomponents/nowplayingbar/nowplayingbar.js","57354928f188852cb11ac7f62242d687"],["bower_components/emby-webcomponents/packagemanager.js","9d69f562ad02229a70ac6dede1fe2db0"],["bower_components/emby-webcomponents/pagejs/page.js","2fa5edd7c9329bd2a698ab79350b79b7"],["bower_components/emby-webcomponents/photoplayer/plugin.js","ccccd76890f911368464fcbf9e14854c"],["bower_components/emby-webcomponents/playback/autoplaydetect.js","f3b855b3774d4e95fd8fdfabe5ceea8f"],["bower_components/emby-webcomponents/playback/brightnessosd.js","59d3d176d7f9b7d6c9734fa9d4910e67"],["bower_components/emby-webcomponents/playback/experimentalwarnings.js","ff28a77c08a4325b7d0dd36ef18150df"],["bower_components/emby-webcomponents/playback/iconosd.css","065fd2e2718631a508e6e7671acd6790"],["bower_components/emby-webcomponents/playback/mediasession.js","7de30a367a835a83a83cf1a330005a81"],["bower_components/emby-webcomponents/playback/nowplayinghelper.js","375261c0a74dc63a06c7224774d56312"],["bower_components/emby-webcomponents/playback/playaccessvalidation.js","8470d1b2ed66586706e947c380e61bd4"],["bower_components/emby-webcomponents/playback/playbackmanager.js","d7597d46b9d0294184f458d043a1b897"],["bower_components/emby-webcomponents/playback/playbackvalidation.js","31d5cb5a21922acd802f67b1645e1fb8"],["bower_components/emby-webcomponents/playback/playerselection.js","fcbf71b891ed1388e72b4bc8a7a2ab2d"],["bower_components/emby-webcomponents/playback/playersettingsmenu.js","1dd5a8519b5d559bae831cfe88f3ac44"],["bower_components/emby-webcomponents/playback/playmethodhelper.js","eacb178681a78af9f4d7f2b99b7c0c10"],["bower_components/emby-webcomponents/playback/playqueuemanager.js","030a8f0070db90a6747db7ba88da710c"],["bower_components/emby-webcomponents/playback/remotecontrolautoplay.js","be3e3e0c2e22bba67a2dd26d2f85f198"],["bower_components/emby-webcomponents/playback/volumeosd.js","8f56dd42ecf2b6fa320567ff708f1b42"],["bower_components/emby-webcomponents/playbacksettings/playbacksettings.js","ae916f3037f88caf154ea18066712141"],["bower_components/emby-webcomponents/playbacksettings/playbacksettings.template.html","93913f21672de192520cef9eae91844f"],["bower_components/emby-webcomponents/playerstats/playerstats.css","097fd8b67751dcaae498ec91ab1a0030"],["bower_components/emby-webcomponents/playerstats/playerstats.js","2a9327e87b19ef16a1703e80949c4715"],["bower_components/emby-webcomponents/playlisteditor/playlisteditor.js","cd0bd5b2c07f51115a087334fd298427"],["bower_components/emby-webcomponents/playmenu.js","70c133f51d146bb34c4270401380ef95"],["bower_components/emby-webcomponents/pluginmanager.js","424a7d4107e99b5f6d3d7acade3e493b"],["bower_components/emby-webcomponents/polyfills/array.js","fa93f686976990bd441bf89ce5fcd92b"],["bower_components/emby-webcomponents/polyfills/bind.js","f35821448b1e67ad3a0e3f3aa8051bd2"],["bower_components/emby-webcomponents/polyfills/objectassign.js","fdd80770e311b537c7224346225c3f83"],["bower_components/emby-webcomponents/polyfills/raf.js","4428b2dbb2078600a417829a3d2d1da7"],["bower_components/emby-webcomponents/prompt/nativeprompt.js","10397466abb51986a0590db990f998d9"],["bower_components/emby-webcomponents/prompt/prompt.js","d0cc25aa0f2860da35eaa1937faf42ab"],["bower_components/emby-webcomponents/prompt/prompt.template.html","e8bf9a838a13eefc69d056510bab7f3f"],["bower_components/emby-webcomponents/qualityoptions.js","f87e31e89af25a67c5284d47870ca4c8"],["bower_components/emby-webcomponents/recordingcreator/empty.png","ce4bf4ab63c7c3d4823cb1e89fdd53dc"],["bower_components/emby-webcomponents/recordingcreator/recordingbutton.js","95f6e3f5bf2069c543ac294e0d374d12"],["bower_components/emby-webcomponents/recordingcreator/recordingcreator.css","c54d42a6053065388fcef8ab358dd269"],["bower_components/emby-webcomponents/recordingcreator/recordingcreator.js","29b8f41a31ddf334316d7a3ff12d7a47"],["bower_components/emby-webcomponents/recordingcreator/recordingcreator.template.html","c70edc6faddfedd508c80a32a9b48181"],["bower_components/emby-webcomponents/recordingcreator/recordingeditor.js","140e0dd008db857589bbf3cc31a2a50b"],["bower_components/emby-webcomponents/recordingcreator/recordingeditor.template.html","8b3b12d113da29bae719f76465d50dfa"],["bower_components/emby-webcomponents/recordingcreator/recordingfields.css","dfb4f8e7f9d255acbe2fe0ae208cce11"],["bower_components/emby-webcomponents/recordingcreator/recordingfields.js","ba284c3788c0e739349f747ea8a676d6"],["bower_components/emby-webcomponents/recordingcreator/recordingfields.template.html","eab5114f0e63113caf89ad797743170e"],["bower_components/emby-webcomponents/recordingcreator/recordinghelper.js","04da0d5b78181010d06b56897402be01"],["bower_components/emby-webcomponents/recordingcreator/seriesrecordingeditor.js","b1c9700375395c0e0fab3902f70aaf61"],["bower_components/emby-webcomponents/recordingcreator/seriesrecordingeditor.template.html","925cf3db879f7cf31d4dc99115d9f383"],["bower_components/emby-webcomponents/refreshdialog/refreshdialog.js","a603cf7c4c8013813a784e7f07b081e7"],["bower_components/emby-webcomponents/registrationservices/registrationservices.js","f55ab2f2560c2da7c3b348655a48b3b9"],["bower_components/emby-webcomponents/require/requirecss.js","ddeeb3617d41e942ca2b2f04fb83af93"],["bower_components/emby-webcomponents/require/requirehtml.js","19b876f9b76262b142a199511c4e9b5d"],["bower_components/emby-webcomponents/require/requiretext.js","7cf0ce32fa9c49c6d0d02ff8dd97ae4b"],["bower_components/emby-webcomponents/router.js","567822b6b0a90bd239c0c6d3734e7dbe"],["bower_components/emby-webcomponents/sanitizefilename.js","4dfa1f51fe7491abfd057dda48b27a31"],["bower_components/emby-webcomponents/scroller/smoothscroller.js","4779793813fead508ff28cf9ac3d49d3"],["bower_components/emby-webcomponents/scrollhelper.js","307172e17df64ea1e960f586cd7e91cc"],["bower_components/emby-webcomponents/scrollstyles.css","d2af041deebd2b30fe1d020a80c0d2c0"],["bower_components/emby-webcomponents/search/searchfields.css","f525c8ae815d9370c11eac04b6819e9b"],["bower_components/emby-webcomponents/search/searchfields.js","102fb12302e88e035717ac0235e4d573"],["bower_components/emby-webcomponents/search/searchfields.template.html","31c600075caab472e47be28d9fba5d64"],["bower_components/emby-webcomponents/search/searchresults.js","e01dc80d5eedfdf1128b26a19456ec5f"],["bower_components/emby-webcomponents/search/searchresults.template.html","a64f03536e9e386878d1b9cd93371085"],["bower_components/emby-webcomponents/serverrestartdialog/serverrestartdialog.js","ab87392ac58619710424277b510df1f5"],["bower_components/emby-webcomponents/serviceworker/notifications.js","e586d6fb71b38f258eefdcfdf9a1b21d"],["bower_components/emby-webcomponents/serviceworker/sync.js","586b9821d24fda02c20e14940d95c410"],["bower_components/emby-webcomponents/sessionplayer.js","bd4d94a7ef622ca45fdef5dfc1f9219f"],["bower_components/emby-webcomponents/sharing/sharingmanager.js","a1ff619b2b25dbee2148e2bbee3402f6"],["bower_components/emby-webcomponents/sharing/sharingmenu.js","b16f2cd433079ba2405856a3276363ad"],["bower_components/emby-webcomponents/sharing/socialsharekit/LICENSE","7c6713a32f1a9092398d3e1fed6cb548"],["bower_components/emby-webcomponents/sharing/socialsharekit/dist/css/social-share-kit.css","766caa5750f457990bb1f0091534049f"],["bower_components/emby-webcomponents/sharing/socialsharekit/dist/fonts/social-share-kit.eot","8c2de2a5fea9c2aa73043c99a91aed6d"],["bower_components/emby-webcomponents/sharing/socialsharekit/dist/fonts/social-share-kit.svg","351e9050538c6075d70c22503a3cc3c7"],["bower_components/emby-webcomponents/sharing/socialsharekit/dist/fonts/social-share-kit.ttf","1603170c4993fdf09cdc8d17f774b5fe"],["bower_components/emby-webcomponents/sharing/socialsharekit/dist/fonts/social-share-kit.woff","14b43c6702b0f8ba368c4f608abd78f1"],["bower_components/emby-webcomponents/sharing/socialsharekit/dist/js/social-share-kit.min.js","b36e76d5d83311bdf980d45a906a67b1"],["bower_components/emby-webcomponents/shell.js","5b40b1c318eca93b9b5b64515afced7a"],["bower_components/emby-webcomponents/shortcuts.js","371f9b3ff399d2dffe4aae57ed9d5735"],["bower_components/emby-webcomponents/skinmanager.js","3b43f61b677f55cb1e95c6783adedfa0"],["bower_components/emby-webcomponents/slideshow/slideshow.js","2bf0e74a7ab0b47714ccda334ebaa29e"],["bower_components/emby-webcomponents/slideshow/style.css","8ec05c434cc2c206e04e83f175031774"],["bower_components/emby-webcomponents/staticbackdrops.js","c572efa11e5bd48d11fa6d80e931887a"],["bower_components/emby-webcomponents/strings/ar.json","62e70e9b66e8d0d7285afa7cd46a00ea"],["bower_components/emby-webcomponents/strings/be-by.json","31633ac4d1c4d1637bcc3c6f19028f88"],["bower_components/emby-webcomponents/strings/bg-bg.json","f6e70a2a257c915304ace2dfbad3e33e"],["bower_components/emby-webcomponents/strings/ca.json","13af74536b6ef33c006a8dae9ee8e71a"],["bower_components/emby-webcomponents/strings/cs.json","6be4cba8fc06ff6a96fdec26844a530a"],["bower_components/emby-webcomponents/strings/da.json","5f64d6b836474842a47444fc58a29c9c"],["bower_components/emby-webcomponents/strings/de.json","8d6ba248e1333f70b803850130d946f7"],["bower_components/emby-webcomponents/strings/el.json","73b8a2ea7d518c23672be026dd60dc8f"],["bower_components/emby-webcomponents/strings/en-gb.json","b89f3ab1b2a5524373820a261f661617"],["bower_components/emby-webcomponents/strings/en-us.json","116d019d8923fcba5341de4289f9d9d8"],["bower_components/emby-webcomponents/strings/es-ar.json","a004ca474f3e5357db3a2d69f99222d8"],["bower_components/emby-webcomponents/strings/es-mx.json","67b942cb7ccfa32da77e988705323784"],["bower_components/emby-webcomponents/strings/es.json","7bcaf3a6eada47284bc33561664ce6ae"],["bower_components/emby-webcomponents/strings/fi.json","9a1261c7fdb42b192c374fd7feb08bac"],["bower_components/emby-webcomponents/strings/fr-ca.json","fc74453727bf998f818ccad861ca0afe"],["bower_components/emby-webcomponents/strings/fr.json","e3e7c2246213cabec83880d0c8dd1e41"],["bower_components/emby-webcomponents/strings/gsw.json","71e6060b3ce03ba55ad2fe1e5458d958"],["bower_components/emby-webcomponents/strings/he.json","440f2ff7038900a792cb721c754038a0"],["bower_components/emby-webcomponents/strings/hr.json","519d505e02d415ed5426ebf6748f119d"],["bower_components/emby-webcomponents/strings/hu.json","f12408d333cd553fc08cfd5f9b053e80"],["bower_components/emby-webcomponents/strings/id.json","e57a2feb05672b4446b110a7165b34e9"],["bower_components/emby-webcomponents/strings/it.json","3717da543cdf503902697e09485a966f"],["bower_components/emby-webcomponents/strings/kk.json","94299ad82fb9fa10f24b34ac31f658fb"],["bower_components/emby-webcomponents/strings/ko.json","f59c99ca0e22bed5e29fdb77d0f2a93b"],["bower_components/emby-webcomponents/strings/lt-lt.json","dcf9245f40c1a9000f6c8f0117388483"],["bower_components/emby-webcomponents/strings/ms.json","948ca179dc77df0175d8d603361ee16b"],["bower_components/emby-webcomponents/strings/nb.json","8f0bd90e72142a7736fc1f0571fdbf56"],["bower_components/emby-webcomponents/strings/nl.json","244224ee2bf6356041829a116d3e0cae"],["bower_components/emby-webcomponents/strings/pl.json","29381f1bde7b73c4b126ffd8cb3c860a"],["bower_components/emby-webcomponents/strings/pt-br.json","59120485add83591210f2a3982deffc8"],["bower_components/emby-webcomponents/strings/pt-pt.json","5f07f11cbcdc465da5fb5bac13cda771"],["bower_components/emby-webcomponents/strings/ro.json","f0e19804235ba721fa5c5117e3e8e5ff"],["bower_components/emby-webcomponents/strings/ru.json","d47adfe4457b4e9b6dfc50ae8b4cdbea"],["bower_components/emby-webcomponents/strings/sk.json","9f4862bf59b8ca252bdcbb58211ebe3a"],["bower_components/emby-webcomponents/strings/sl-si.json","0d1b406a052ea1ee5108cee06a3cc4b0"],["bower_components/emby-webcomponents/strings/sv.json","bbc8a5b2096bf5d1961c3996210e0a8c"],["bower_components/emby-webcomponents/strings/tr.json","065d10fd3f844c6d4e46956e260d2846"],["bower_components/emby-webcomponents/strings/uk.json","2ea2f283bb5c5023624c73446d491677"],["bower_components/emby-webcomponents/strings/vi.json","f64d8a8fde522b8b0f0228df223216c2"],["bower_components/emby-webcomponents/strings/zh-cn.json","eecf922f528d4aac0aa255943af65592"],["bower_components/emby-webcomponents/strings/zh-hk.json","021a02c710730ee8b5f319cdb1191430"],["bower_components/emby-webcomponents/strings/zh-tw.json","4e768248c83bdf6677d232fdb29f8a25"],["bower_components/emby-webcomponents/subtitleeditor/subtitleeditor.css","26c07aae32e14a365642dbe454f74286"],["bower_components/emby-webcomponents/subtitleeditor/subtitleeditor.js","10fed2dcec987c5eed39f46541f61593"],["bower_components/emby-webcomponents/subtitleeditor/subtitleeditor.template.html","739f699421684c0ea0485f98a452f13a"],["bower_components/emby-webcomponents/subtitlesettings/subtitleappearancehelper.js","cc1f85c2d9cabeab57b94d7fe7b3cae2"],["bower_components/emby-webcomponents/subtitlesettings/subtitlesettings.js","1bfba89f8f6590c25bfe146e217f3a18"],["bower_components/emby-webcomponents/subtitlesettings/subtitlesettings.template.html","ebe5debca8d54b8294c6f0ecc7868a6e"],["bower_components/emby-webcomponents/sync/emby-downloadbutton.js","c9b6d42cc9ce08a7cd1121a77594dfb8"],["bower_components/emby-webcomponents/sync/sync.js","5667a24ae6b65964fc4277530e8fcf0b"],["bower_components/emby-webcomponents/sync/syncjobeditor.js","3e51e601fed9d69223551d8b21f3238c"],["bower_components/emby-webcomponents/sync/syncjoblist.js","0a688f03488dbbe9be26ff5ff4a99223"],["bower_components/emby-webcomponents/tabbedview/itemstab.js","5fa9f0df176df9ad8c76370f6e75c4fe"],["bower_components/emby-webcomponents/tabbedview/tabbedview.js","ce4d9072c609f363761a39011afe8b29"],["bower_components/emby-webcomponents/thememediaplayer.js","d5e277ebf4311c0cddea9bbb89bb5f53"],["bower_components/emby-webcomponents/themes/appletv/theme.css","eb358c8e03478784e123e8a6cdbfff43"],["bower_components/emby-webcomponents/themes/dark-green/theme.css","2b3f7f1347f740888471251106763b7b"],["bower_components/emby-webcomponents/themes/dark-red/theme.css","b61b3c19a907731d8c8cb6bf88a395f0"],["bower_components/emby-webcomponents/themes/dark/theme.css","ab90972a6441072718fb4897c26f26c8"],["bower_components/emby-webcomponents/themes/halloween/theme.css","5845b25315535874750bf712fd4a1d6c"],["bower_components/emby-webcomponents/themes/light-blue/theme.css","d3e9cbd5d7a2fc19385f10928766c964"],["bower_components/emby-webcomponents/themes/light-green/theme.css","4161fe508fef18374613e243a8a523d0"],["bower_components/emby-webcomponents/themes/light-pink/theme.css","5587072e1e0f77c6505d96e3b4e01526"],["bower_components/emby-webcomponents/themes/light-purple/theme.css","ac8908edb34e9c5eb1fbaeb9defdf264"],["bower_components/emby-webcomponents/themes/light-red/theme.css","4680859c435e28ebccfb2c6d7683a213"],["bower_components/emby-webcomponents/themes/light/theme.css","d2e3b9e1d54624a0e8ac3e6751dfd17a"],["bower_components/emby-webcomponents/themes/logodark.png","c39f5b882ddfb71540e2554f750603bf"],["bower_components/emby-webcomponents/themes/logowhite.png","3d41717565266a677775b984386679c0"],["bower_components/emby-webcomponents/themes/verydark/theme.css","30c686fd204f65c2976c29c86eb9d2a0"],["bower_components/emby-webcomponents/themes/wmc/theme.css","9778169e50eb74ec2d059e5bc22b2b35"],["bower_components/emby-webcomponents/toast/toast.css","b83d9755d7a73edd9f31bbf3900a2aae"],["bower_components/emby-webcomponents/toast/toast.js","0f54ab7949c263e5b199cf33863ec9a0"],["bower_components/emby-webcomponents/touchhelper.js","8d01f08d888fcd3b1922aad0ebd2bcd3"],["bower_components/emby-webcomponents/upnextdialog/upnextdialog.css","67aae26451ac3cbbe0cbb152c332cc50"],["bower_components/emby-webcomponents/upnextdialog/upnextdialog.js","9df4b0fca1a4011b4a5bda534ddf9a91"],["bower_components/emby-webcomponents/userdatabuttons/emby-playstatebutton.js","b62c242a6946093a5731f1313fda8205"],["bower_components/emby-webcomponents/userdatabuttons/emby-ratingbutton.js","7548d0998032b3c6f5999314ff3c4888"],["bower_components/emby-webcomponents/userdatabuttons/userdatabuttons.css","5e7c14bb12c6411fa979086b3b2903a4"],["bower_components/emby-webcomponents/userdatabuttons/userdatabuttons.js","6435a542bc8a0da3a932a8a65a95a558"],["bower_components/emby-webcomponents/usersettings/usersettings.js","69bc544f31c55ee9a4958a8539492f08"],["bower_components/emby-webcomponents/usersettings/usersettingsbuilder.js","e32c0af8b123d728e66b0f9ddb0253d6"],["bower_components/emby-webcomponents/viewmanager/viewcontainer-lite.css","ae2bbc3ba78543f91466efc8461fd705"],["bower_components/emby-webcomponents/viewmanager/viewcontainer-lite.js","4d9e8be0da8da58d0957dd88a0cafa02"],["bower_components/emby-webcomponents/viewmanager/viewmanager.js","0ea5b12b14dcd1f1e10b177963b2ab62"],["bower_components/emby-webcomponents/viewsettings/viewsettings.js","29daae91ae4923fc861122ad35edd988"],["bower_components/emby-webcomponents/viewsettings/viewsettings.template.html","6e401f4edd2fddb0d9d1f304a84f6ad5"],["bower_components/emby-webcomponents/visibleinviewport.js","f07a934bbd6f363efb59043e7dd5a74a"],["bower_components/emby-webcomponents/youtubeplayer/plugin.js","cdc05d72b29e73f3107b240cf4536dcc"],["bower_components/emby-webcomponents/youtubeplayer/style.css","f392a11d7bd325d79cbbe313058ef863"],["bower_components/fetch/LICENSE","d35eef4fa0e8d955074e349234dd0e25"],["bower_components/fetch/fetch.js","a4b216c927f114bf28de4deb08973914"],["bower_components/hlsjs/LICENSE","ad8523671ccecfb2ed64ff84f7221d1e"],["bower_components/hlsjs/dist/hls.min.js","8361666e7e2690d988ff5fe775b62bbe"],["bower_components/hlsjs/hls.js.sublime-project","14813a645a47a367bd3f6b19d33cbfe3"],["bower_components/howlerjs/dist/howler.min.js","d16a8bf88341368b7d348752c7cb3c50"],["bower_components/jquery/dist/core.js","679d140db1c96855963922da29551760"],["bower_components/jquery/dist/jquery.js","41f26188068549fa60c41861f0f2291a"],["bower_components/jquery/dist/jquery.min.js","473957cfb255a781b42cb2af51d54a3b"],["bower_components/jquery/dist/jquery.slim.js","96f92c40b10ab17c435454d555a38cc8"],["bower_components/jquery/dist/jquery.slim.min.js","f307ecc7f6353949f03c06ffa70652a2"],["bower_components/jstree/LICENSE-MIT","397726ed672fd7a39263d77579a326b6"],["bower_components/jstree/dist/jstree.js","fc37b2b9b037fcf7c1ff902e3ab42a2b"],["bower_components/jstree/dist/jstree.min.js","ebb57701ee52c7f3fcb7d89c0d36cdc2"],["bower_components/jstree/dist/themes/default-dark/32px.png","eebaf260766f5e0e773f53d3ea4f3e4d"],["bower_components/jstree/dist/themes/default-dark/40px.png","51286e68b083696edaf4f9fc577e2a2d"],["bower_components/jstree/dist/themes/default-dark/style.css","8f8bc0c8eb88f326c287516be296fba5"],["bower_components/jstree/dist/themes/default-dark/style.min.css","fdbb497cbbae21a31a1330d34d2f1307"],["bower_components/jstree/dist/themes/default-dark/throbber.gif","62be6ed2b189444b472b8000dc187240"],["bower_components/jstree/dist/themes/default/32px.png","db49c8de4f267eede40a9a8843efcdec"],["bower_components/jstree/dist/themes/default/40px.png","1f075735090412ed7eb8077d819b19c6"],["bower_components/jstree/dist/themes/default/style.css","74c499dd65c6905c153ed3870f0bb379"],["bower_components/jstree/dist/themes/default/style.min.css","e9e5f5b94babd026da4c605031e22313"],["bower_components/jstree/dist/themes/default/throbber.gif","9ed4669f524bec38319be63a2ee4ba26"],["bower_components/libjass/LICENSE","3b83ef96387f14655fc854ddc3c6bd57"],["bower_components/libjass/libjass.css","e3dc448d50e349df24b26e791e02cb1e"],["bower_components/libjass/libjass.min.js","bb8808a5932ce7ea4cff9083c96e1411"],["bower_components/query-string/index.js","918cc96f7e69e412187032e613a71cfe"],["bower_components/query-string/license","940fdc3603517c669566adb546f6b490"],["bower_components/query-string/test.js","24bc50eee927a290d38a466a73bc1e1c"],["bower_components/requirejs/LICENSE","4542b439beb87b2096e9bb8363d89df4"],["bower_components/requirejs/require.js","5e839b4bc78ef663662422c3ad423a0b"],["bower_components/resize-observer-polyfill/LICENSE","5fcd14546fae799d0cb4506bc30fe185"],["bower_components/resize-observer-polyfill/dist/ResizeObserver.js","7b0dd53e7f223987c0d93348d13c0562"],["bower_components/webcomponentsjs/webcomponents-lite.min.js","b302282329b23c129971c9d7937b14e4"],["camerauploadsettings.html","45d0109b65b9a9234fea6497acadfe91"],["channelitems.html","f0d78f12ac53061ec315b21f7695b0dd"],["channels.html","6ed738b90d2afdf9fcc848d2231a8d4a"],["cinemamodeconfiguration.html","b18b0a30d25e707dc897d7d17df21076"],["components/accessschedule/accessschedule.js","61b137d828706e1595155ee292337df3"],["components/accessschedule/accessschedule.template.html","10a2acb6a10fe88039c9c731a51cf29b"],["components/activitylog.js","a25bec3f2f60ea2ad552dc9604b2ffdf"],["components/apphost.js","41cce94d414fd761b1ebe1b3bc569546"],["components/categorysyncbuttons.js","2a0547cbd057e2f70b9b515a4f518eb7"],["components/channelmapper/channelmapper.js","e0b76ff88be0bb006abdff190969bb48"],["components/directorybrowser/directorybrowser.css","70963365fa58ea805dfbce1fcb76efd3"],["components/directorybrowser/directorybrowser.js","25caf69c8dae1082ec4e626b66a153d8"],["components/favoriteitems.js","dfa89bf6677929c78e69aca0a83378d1"],["components/filterdialog/filterdialog.js","3f4abe1eb0e721cf5447db2346d1ea4c"],["components/filterdialog/filterdialog.template.html","eecf297b5b3f839f1baed35ca997ceee"],["components/filterdialog/style.css","e1cb59049c7dd8d64b4261bf6f9410a1"],["components/groupedcards.js","b1a2887cafa5de6f673610240f5c3a50"],["components/guestinviter/connectlink.js","e4e9d7356b2d7d5112167d34377fb5e1"],["components/guestinviter/connectlink.template.html","a1291df309cc6b806423f8afbf95a44f"],["components/guestinviter/guestinviter.js","285e1d67aa4f998e1f8dbf5c69575a8e"],["components/guestinviter/guestinviter.template.html","4c3ca358550812a6a1879ec251c9c60a"],["components/humanedate.js","ef99790c1b8e4b37abaab5f3cbbae07d"],["components/iap.js","d5833fdcc347f8fb4e474f8c4f5be148"],["components/libraryoptionseditor/libraryoptionseditor.js","f3ef1fbdcd12ced17170f396ff031760"],["components/libraryoptionseditor/libraryoptionseditor.template.html","3985de05c53dcac1d6034b1f685d2ec9"],["components/medialibrarycreator/medialibrarycreator.js","bde819ea21329b668c2ebfe3cd144a14"],["components/medialibrarycreator/medialibrarycreator.template.html","287998e18ef23d9282503df03f7e5d46"],["components/medialibraryeditor/medialibraryeditor.js","78b200b6760a283de074e57576a22b5a"],["components/medialibraryeditor/medialibraryeditor.template.html","f38fbcf5ce26ceaa4b3ddf998cf010bd"],["components/navdrawer/navdrawer.css","d25c9940095669d7d88554a45cb89ead"],["components/navdrawer/navdrawer.js","dc9a2c459a28ec232bb99ffb89fb3a57"],["components/remotecontrol.js","447be92ab5ce6f9e09fe065ce90f0767"],["components/tunerpicker.js","d7e07791ca68ac52855e0b7131f0f917"],["components/tvproviders/schedulesdirect.js","e2df562a5c46e05956ae8994985505ad"],["components/tvproviders/schedulesdirect.template.html","d22b73d98fd858f85cac15d3b380e0ad"],["components/tvproviders/xmltv.js","1280b9e6c9bf182cee06bbe991e4a036"],["components/tvproviders/xmltv.template.html","3960fa465ef1443626a735243a63d8fa"],["components/viewcontainer-lite.js","c0c270b1918767fad9b80f2ed282148f"],["connectlogin.html","ff5f298fd207b05c25eff0fdb56436c7"],["css/dashboard.css","bffc1849aad8a99d6f04840d7739cac8"],["css/detailtable.css","0611aa5c338baf8e992a30de0af72eb0"],["css/images/ani_equalizer_white.gif","568a1b83c98f2d86f4bcceb5c748c7b5"],["css/images/clients/amazon.png","f333783b4d83dd6d11794e3d2aa73417"],["css/images/clients/android.png","f3e81fd28a35a225b6550b1382efbda7"],["css/images/clients/chrome.png","8276f1858d2d6537f74423f496f33136"],["css/images/clients/chromecast.png","0e0e2d8ca49b8b450493d80bf02d89bd"],["css/images/clients/dlna.png","dbc161d8bfda2287e6aefc662a821766"],["css/images/clients/html5.png","af94195fc50915e30cf35eb38f297049"],["css/images/clients/ios.png","35713e3f68e104a2a68c82746784e25a"],["css/images/clients/kodi.png","bab1168b23518e298166cc73339db7a2"],["css/images/clients/mbc.png","85749ab52695b0e957166594eb569fd2"],["css/images/clients/playstore.png","70177dd8277ed79d518d0fee70bbcdde"],["css/images/clients/roku.jpg","5b13e6b88f2f2d36a9f5bd345d394663"],["css/images/clients/windowsphone.png","2b321cef34908d36f26489fb6494d171"],["css/images/clients/windowsrt.png","b30615b4f1dd65d4943c2bd5ef774d7b"],["css/images/editor/missing.png","a5be962e185a4e762bcb75809103cdaa"],["css/images/editor/missingbackdrop.png","7f94a256013e1b55c009b242a879e996"],["css/images/editor/missinglogo.png","1ad9893b8d0bd57be30445fb155c56c7"],["css/images/editor/missingprimaryimage.png","fbd63132207ca761336b972e97d56ddc"],["css/images/empty.png","404efd0017e23b1130d6da609202da55"],["css/images/favicon.ico","8df2318cae6c03a85179b744108645ba"],["css/images/iossplash.png","5e00bfcde3dc12d5e739031ecb6e9f9e"],["css/images/logindefault.png","c0333d789150f5a0f2180047ee49ae15"],["css/images/logoblack.png","c39f5b882ddfb71540e2554f750603bf"],["css/images/supporter/nonsupporterbadge.png","e436d397a0f6e8443da0559dcdb7f554"],["css/images/supporter/premiumflag.png","9353f6ca1367c309867b113b901fe81c"],["css/images/supporter/supporterbadge.png","e83fb4cd3bfef2e5f371f8b938ecc295"],["css/images/supporter/supporterflag.png","b8325b67444f332de84e2275291955d5"],["css/images/throbber.gif","9ed4669f524bec38319be63a2ee4ba26"],["css/librarybrowser.css","077e20896ff9e503fbccda4fd84f57e7"],["css/livetv.css","3ef29414ad6321f6052a013cb42c4260"],["css/metadataeditor.css","a2ab28eee234536a922817408836edac"],["css/notifications.css","24b49fa2d762b5927775079988ec4b62"],["css/nowplaying.css","cbabc41b73d4d8187370a61fb628ba4d"],["css/site.css","3ca72b0cc9f868f78400257468d62c5d"],["css/videoosd.css","90ef2659b5916a1013b2167304ff2745"],["dashboard.html","5cc02874651e72af0ac37a31e00c1b95"],["dashboard/aboutpage.js","9302ac466209fcc01cadcc320d86be9f"],["dashboard/cinemamodeconfiguration.js","bb509927fe10d076f1d7c203e464c70d"],["dashboard/dashboardgeneral.js","936184c8e3f00c922d2e6b5912d9e99f"],["dashboard/dashboardhosting.js","816da1c21f5ffbca8c4bba20cacd4e05"],["dashboard/devicesupload.js","d6d80d8492b1cb42e49915bf4a255a0c"],["dashboard/librarydisplay.js","7f2eb1b8fbe15f53d583c510a9c4c752"],["dashboard/librarysettings.js","9158f31262b1aee837464b27e4122ec3"],["dashboard/livetvtuner.js","c8d4937c2c993585d2cae6e52afedfb5"],["dashboard/logpage.js","2ee797139f19c99005115b2e2b1971cf"],["dashboard/wizardcomponents.js","211c7704f49362028eb4ff7d9170444f"],["dashboard/wizardfinishpage.js","c4078795d0846e0a6aa22304f6605444"],["dashboard/wizardsettings.js","916fd47adde0146618d9b1b1e07f2e12"],["dashboard/wizardstart.js","f377484a5b564dfa317e372830530205"],["dashboardgeneral.html","6babe6d14a176773e61df26a700cf0fd"],["dashboardhosting.html","c563a0ed95cc91d340f4486f9cb9316e"],["device.html","444a1ae4aafeb1dbaea5e94ad1375ae0"],["devices.html","704d40d1563407598afe045c2049c90d"],["devices/ios/ios.css","5b663574b5603c96240aafc5cec82a9a"],["devicesupload.html","1aefb59dba3499b63c8a3abe64bc4ce2"],["dlnaprofile.html","ef6ace5503ee64d48cec84c80751ad2b"],["dlnaprofiles.html","80e60336d61577697030db1bee5d561f"],["dlnasettings.html","53ad3ec8917a3f80f4b6fce9730fda0e"],["edititemmetadata.html","ad97444d8755153a63defdff5a6c039c"],["encodingsettings.html","258d8171ccd4fbc5982fc0f900e1087b"],["favicon.ico","aafc0ee04260df66d2d6460f140e5a24"],["forgotpassword.html","90fe7493845d2cb3c52f29f3c9cb544c"],["forgotpasswordpin.html","63868ae685f0575c29b69cb9c186597a"],["home.html","72644fd91996b2f98950660cf02eb26e"],["home/favorites.js","7a377df64833cbf5f039b220aa9c45c8"],["home/home.js","950e4c6b10fcc03ab3b995c93b39e6f6"],["home/hometab.js","362be802ef1c3d58e0f8ff4602f7f331"],["index.html","4ea48e316f11f1087b7632af7ca426a7"],["itemdetails.html","375af75f650e69f55e0ec825efec7e35"],["itemlist.html","08349a9ff7201f26fec27f9075b8aad1"],["legacy/buttonenabled.js","90f266fb967e3ee0e80c2607137aa121"],["legacy/dashboard.js","2621ae78e04076fc06ba14e3772bb3f3"],["legacy/fnchecked.js","b76b48776441126c4d2f7553ac871696"],["legacy/selectmenu.js","247c11c5a97e08fef6806bf056252cea"],["library.html","0b703b2c018bfe15220b7d1510261ad1"],["librarydisplay.html","10b338f84bbecf2037287571c393333a"],["librarysettings.html","a0a23f086b8301177176d3474488d818"],["livetv.html","a27896a63a1a2ab5651d9ff7f30eda82"],["livetvguideprovider.html","ac1c14fa9754535fe8878bc62d8a7b8d"],["livetvitems.html","b6243d505ef5de03c990291c2277976b"],["livetvsettings.html","40571a3508e2c7e80afa7fb2f9896d1f"],["livetvstatus.html","57f360bb8a596def13a5010230855239"],["livetvtuner.html","3f53c2de44f31aed8e53aaa1ae13cf53"],["log.html","a32e84463cb231e6deb6d41bd0dfed44"],["login.html","72c3e6a3eb14e71e172f644e8ee9677c"],["managedownloads.html","72d7b1afbda2d409cd78de262d4afc01"],["manifest.json","85b615b9d52a260b4cb90d9779e35b96"],["metadataimages.html","dcda6b7f1dc0620840ad1a7145a2ce48"],["metadatanfo.html","da33967f5eb9c85b35e31d9a55a1521f"],["metadatasubtitles.html","9239b32243cdc9d23151907abbdac4de"],["movies.html","f730db07ebeafd6f014eba34c09ecd1b"],["music.html","35d8eef01f61b16f538dc3ce7fa1892d"],["mypreferencesdisplay.html","20954556008e0db1120adf333c7b2285"],["mypreferenceshome.html","ab03d0dce2f3f35cadb7e20b925969b0"],["mypreferenceslanguages.html","e8feb0b20907ed235a1748324b922ebf"],["mypreferencesmenu.html","0fd10970f03a0ab1b2556f67d6f55939"],["mypreferencessubtitles.html","36b9921b44af0a7aa3a15088d1586254"],["myprofile.html","9a7c99ac84a49b8e52841cc282f069e6"],["mysync.html","c7dde6bc3523e86b328d67dd82161e2f"],["mysyncjob.html","90331975e03e4e61d629f3be74cb5c83"],["mysyncsettings.html","15bc52e5db1b289fb23bfdf98e9a0477"],["notifications.html","0f128edf7e6a5acf3a5c6874d8a6c9fe"],["notificationsetting.html","12a1349ac483340aa9e8ff00976588c8"],["notificationsettings.html","e618a274e7c3e5ad0a7c2157356dc0a4"],["nowplaying.html","7c53e8d2420bb061f113ff7f039096c9"],["offline/offline.html","56999ac82eaf19519b8c2a8ef1000eff"],["offline/offline.js","78cbf793d194686f261c95a0d43a7ba1"],["photos.html","be59aa55afeaa1343e719d4de617cf88"],["playbackconfiguration.html","5c65a5eb73758d6b05fb441e69369b6a"],["playlists.html","d2d03e68ada115b87d3c3f6d34a469db"],["plugincatalog.html","856a974e18922fa8589eb9e85c74071a"],["plugins.html","65c5c9364fbca170e84baf0f2de0739f"],["robots.txt","bbbcde0b15cabd06aace1df82d335978"],["scheduledtask.html","428a5097c7f5cf1597c9c741d3f88220"],["scheduledtasks.html","516157e28f44fa07028317087a61b2f6"],["scripts/addpluginpage.js","470689e5809add733161bd6c226c77ad"],["scripts/apploader.js","87767e1a55425b3af5aa60bcda5b2a65"],["scripts/appservices.js","31aaed9f750e900ed86a14bdc38eaa2e"],["scripts/autobackdrops.js","448a445dfca9f07b7df84a064a617774"],["scripts/camerauploadsettings.js","eaac091067f20a5090d7650daac0b72a"],["scripts/channelitems.js","a747565d47af349a3fc4add31a1ce2c2"],["scripts/channels.js","048be35d2b5f6e962e3bd44be3361d91"],["scripts/connectlogin.js","82ab44a7b4c7d54ad32c12a20e300f26"],["scripts/dashboardpage.js","0c7f17428cbcfc11542f4958b0ef9a93"],["scripts/device.js","d752ea72d6f40b8d0b4977d0f843c02c"],["scripts/devices.js","17d302eed0fe9acda8f04fff56eccce5"],["scripts/dlnaprofile.js","875a80057f5a03e065ea5bf19ae198c8"],["scripts/dlnaprofiles.js","f55e0e4eb681f856f76f263e160d0ea7"],["scripts/dlnasettings.js","01eff13dcb51367c1325e7de8d86969d"],["scripts/edititemmetadata.js","cdc0bdaec48434a450e4cb447109ecf9"],["scripts/editorsidebar.js","755cdeb6b3139437a725f7a67f3f0e42"],["scripts/encodingsettings.js","3848d2aa52e1b7f425fdf944b5780717"],["scripts/episodes.js","2efaf06a8077e15a9229deaf72a4f0cc"],["scripts/forgotpassword.js","aa4c1203b280b544b2b250dbfd031a8d"],["scripts/forgotpasswordpin.js","f0e6bd422c441ccdd2f205d7569ae88e"],["scripts/itembynamedetailpage.js","8e79f0304ac881aaedd3f8680e8a3738"],["scripts/itemdetailpage.js","ec9e3dffd732bdd53e37c12eb0ddc863"],["scripts/itemlistpage.js","bf783904b243c64ded4b95e644fcde5c"],["scripts/librarybrowser.js","dc82dc1d31699e72718b087ee726008b"],["scripts/librarymenu.js","22dc2b90f7893411c587be1b7f311811"],["scripts/livetvchannels.js","428748357ff8cf02382318d9d2c67432"],["scripts/livetvcomponents.js","e3748be8f5e7e06e730985ae4172c9ef"],["scripts/livetvguide.js","f42d4a3de553d3138724f34812c1ee29"],["scripts/livetvguideprovider.js","89d44ffa621226edfdd18c983433d4d8"],["scripts/livetvitems.js","7bc2d99d7faf35d10fe9d0a93f65434c"],["scripts/livetvrecordings.js","1b3e73eeb25f54d57550eed6bf6aae72"],["scripts/livetvschedule.js","4c7ac793d6b4318d885e102702706fe0"],["scripts/livetvseriestimers.js","f14edde9b96a42da96b2ea59f1800d76"],["scripts/livetvsettings.js","f9c653b45138452160ee8e4074f1abaa"],["scripts/livetvstatus.js","a8bea99dc9f0376deac7df6e1ffdc487"],["scripts/livetvsuggested.js","4d3f879cdf96fa745a10d51c7ff72e77"],["scripts/loginpage.js","d2fe7d26decd9bc2ebb1eb525496e554"],["scripts/managedownloads.js","27143b5e10fe925ecff20e8af11cdcda"],["scripts/medialibrarypage.js","d567a0c51bdeef2b3250e9bf816b2314"],["scripts/metadataimagespage.js","f050421dce35d6b1d1a92daddc2bf3dd"],["scripts/metadatanfo.js","df6899bd4b0179c8cd5bb20c1e35b2e2"],["scripts/metadatasubtitles.js","eb097dd3de3a943772b47c9af715830b"],["scripts/moviecollections.js","5522d9732f22d8c3c4cf64bb1400e520"],["scripts/moviegenres.js","f84775a9d05caa89ac2c6503e11cb5bf"],["scripts/movies.js","b0226d156535e57decbde3bda651ba5c"],["scripts/moviesrecommended.js","8023cf5282c7e1797e325edfd70975b7"],["scripts/movietrailers.js","258974a3f8fb96882e0efed05279886d"],["scripts/musicalbums.js","504a79a596b80f8d7e2ab01bff8134b0"],["scripts/musicartists.js","70b9039392783905bf36f4177b26c47f"],["scripts/musicgenres.js","1a829c2f955fc29a20b9899cf3b82321"],["scripts/musicplaylists.js","d38425106726e422ec91025fb77b9213"],["scripts/musicrecommended.js","b3705cb8ff8979b69c718c2d97e4754e"],["scripts/mypreferencescommon.js","efa6ebec298b89822e6c8e4357f74134"],["scripts/mypreferencesdisplay.js","f30f80199b3d6c5648c98714882610e0"],["scripts/mypreferenceshome.js","c11262d78fd0c2bad02c6875b9d33c33"],["scripts/mypreferenceslanguages.js","437f6f63bb6e6db440c660f5f056e671"],["scripts/mypreferencessubtitles.js","8aaf9c2e9216158ac71a95a367c082d2"],["scripts/myprofile.js","ce30f321bd70e2048f7d8e6f74365d59"],["scripts/mysync.js","8908ab19f1d2e8b2a1a74b2a2007dd76"],["scripts/mysyncsettings.js","6141b2c4c0038b57fd3d892025e17f68"],["scripts/notificationindicator.js","19427a75ac347ea4129ca71ae95becc0"],["scripts/notifications.js","9b1613dcab9a31b83941aa2cf24f1c87"],["scripts/notificationsetting.js","e73e8a688333ea058c974e0593b7d642"],["scripts/notificationsettings.js","0932bc003f2f12fbb907b93ea32215b9"],["scripts/nowplayingpage.js","e3d106ad5c057d1f6c3977ad3bfd0e73"],["scripts/photos.js","f856df19d005e0848afa28ce9e722ba5"],["scripts/playbackconfiguration.js","b023c1e1dd7210ee6bfaf71a178feba1"],["scripts/playlistedit.js","a5a5509e684bfcdad3c99d0d2b2f6b43"],["scripts/playlists.js","6ed9500a28500b7f28a19a587172d18c"],["scripts/plugincatalogpage.js","56ae8703e169c29bd6a57d31d0193480"],["scripts/pluginspage.js","2ae3fd084cdfa413902067bd7df9d757"],["scripts/scheduledtaskpage.js","6516414953a7c7de5d2069d42b8f90f3"],["scripts/scheduledtaskspage.js","933dd92e2df00e7f65e787d28d7aeeb9"],["scripts/searchpage.js","86a69323a239c1098619c69749ceaf72"],["scripts/searchtab.js","d8dddd0261a9d5716ac69c9318c42330"],["scripts/secondaryitems.js","baad05b6ddb3e4cf9e03c0cee0a07d9f"],["scripts/selectserver.js","993b3c4e90e3532b413df1f09f2bb6cd"],["scripts/serversecurity.js","1e8d83a66dac532f16991646631898e6"],["scripts/shared.js","d58c8270ba52b8f4114cb295dd6de0e6"],["scripts/site.js","4a512be5babbda8c69cf8bf8d8528f85"],["scripts/songs.js","f91cc51717bf57453710593bf58d8a10"],["scripts/streamingsettings.js","0e8d97cd99e8ae453be209c9000fa9af"],["scripts/supporterkeypage.js","b009ccb487791ca901eca8e0ff2f8516"],["scripts/syncactivity.js","4f40eeafcc644deac3db7674b4220ced"],["scripts/syncsettings.js","4598cbd4d0f44fe01247b322631a40bc"],["scripts/taskbutton.js","46a5a86fd925cb728cba800dff99d0fe"],["scripts/themeloader.js","c7bb8b42bd1778bdf3daab881be8d8a2"],["scripts/tvgenres.js","fec8f19e40fd5a19f21bf780424e5621"],["scripts/tvlatest.js","5e19257e95acd552be26e6262618101f"],["scripts/tvrecommended.js","2e3ca6d693bb72c9298227238e5d133b"],["scripts/tvshows.js","2adba92395a7768f48e22f8603bf2410"],["scripts/tvstudios.js","891d2dc52cbe0a5b7b84e249cd1f03be"],["scripts/tvupcoming.js","93f148848247a89d023bd978712f8833"],["scripts/useredit.js","e5c5b2073ee007e8cff6ec0c62246f00"],["scripts/userlibraryaccess.js","f3204697fe49e5aa6ef05a8651800664"],["scripts/usernew.js","d3daae7825c98219493dddba27ce0be0"],["scripts/userparentalcontrol.js","6362ff3545cdc687e00aee21aa20311f"],["scripts/userpassword.js","25956c34cd56b20803a7b00b7fc1cee0"],["scripts/userpasswordpage.js","d259ca7387be567c7e976ff3346d7edd"],["scripts/userprofilespage.js","db5e0f7c66062781a0b8d06c44d5d029"],["scripts/videoosd.js","31201bdbed52232eac79705f30fb59fe"],["scripts/wizardagreement.js","af89bfc61429a5713f2ef81c0e578702"],["scripts/wizardcontroller.js","4e4e33f82202f00e2c3e183e0491c10f"],["scripts/wizarduserpage.js","ed4809bab91506d63d7466a55ca3c3fa"],["search.html","f98801bb99406f4e860d0146fb5b42f7"],["secondaryitems.html","bb84cc795c003959ad1c87197e9ca927"],["selectserver.html","1b432372357e389ec8d75ff53435c5d6"],["serversecurity.html","dd416a322104bc02342fa19a7ed404de"],["shared.html","6d10ded3a75f6b7245e764faa01849d9"],["streamingsettings.html","08b0439e7ff67913140fdcb7e270200c"],["strings/ar.json","1463cf145efe1e28c1cff15307bf4284"],["strings/be-BY.json","38ec4080b439e0b70c153ffff0afb4a9"],["strings/bg-BG.json","85fe51d948b7f7644ca4bc1ea1daff5f"],["strings/ca.json","5f50029b706a21e5ba50d9075a1884fb"],["strings/cs.json","03db1b6745b2e3ebdc8901eae385bf26"],["strings/da.json","3c0af035332513a20126c37e06a333fd"],["strings/de.json","f87c3adde24c1a1104b7779b036bd523"],["strings/el.json","340fc387f7ba07bb6edb6941246f2570"],["strings/en-GB.json","d2b42ed486d5fcffd0309b45421b6955"],["strings/en-US.json","284a6d7ac2855002a876d46c5738bf71"],["strings/es-AR.json","7a2bd99cf9e68c4eedc78d2fad54bc33"],["strings/es-MX.json","a45af55bdeb731723e04b8ca3c96522b"],["strings/es.json","90ca44f704d045cd0c5ee1d241860407"],["strings/fa.json","7c95d6089920e950de92191aa714bf0d"],["strings/fi.json","9d5b2e1b930f9d83b6eecf384169438b"],["strings/fr-CA.json","078b07e36969e2a6c288b4e1ba2d1553"],["strings/fr.json","40b7e2b2a7e362664cec282c9056ed52"],["strings/gsw.json","b1953471a874ae407b64e2b3cf3f5142"],["strings/he.json","ed7de405a06de26b7a773f66b03fb33e"],["strings/hi-IN.json","3fcba2c84a9b91e774503031c2b1fc77"],["strings/hr.json","a40b0322abb330f66c371eda87b662e9"],["strings/hu.json","50fd97181eaea3c28dca2c9ca1f69161"],["strings/id.json","6c92ea38d7cecfa2d3ef073be8fff69a"],["strings/it.json","cf8d3f36d18c99aba8dd23860f869140"],["strings/kk.json","2535f5d455cfb8f8f7475b67a860b295"],["strings/ko.json","de7183da75ab6d163f2bf8d9e1f5b9aa"],["strings/lt-LT.json","74d5d6c7348e00eedc90bd9f71efb224"],["strings/ms.json","6780e9e85baec9aa8da903f0d7d34c7f"],["strings/nb.json","7c338f78c36f310cc2a558cbf9416c34"],["strings/nl.json","38e031a175f2aa2edd9052f0340c4147"],["strings/pl.json","c59e0ad35d9fa8c1ad040b9601360659"],["strings/pt-BR.json","b6cbe58808cd4a524acb6613bf3b009b"],["strings/pt-PT.json","c954d804e6dca3cf7295000aca15ac3c"],["strings/ro.json","23c0e34dfa33cc485801fbb84cf7589f"],["strings/ru.json","7ab4b370c1f0418445774db81bdebf4e"],["strings/sk.json","cd0e2867445e03c507074557cf93117a"],["strings/sl-SI.json","bca09fa2dec945946b50169a35b91a4e"],["strings/sv.json","960c99309eb887a80b468884347ec1ca"],["strings/tr.json","6eb544042a88a46d2f6dff1a814c9278"],["strings/uk.json","a6056faa0039b0728bd9a597bac286cb"],["strings/vi.json","f5217e7277d9c39e129e983262500983"],["strings/zh-CN.json","541c7e9db41ce804fd2890958cbc3c84"],["strings/zh-HK.json","f571884ab26060bd14dbb07e1de70812"],["strings/zh-TW.json","51af3678be6f11fe14177b2d4925428b"],["supporterkey.html","247a18cb27ba31480daee736d8db2947"],["syncactivity.html","c6fba55ae6663b98aec0d2c4d072be72"],["syncsettings.html","8496efbdb3720bad8ddd84a49f6d2361"],["thirdparty/jquerymobile/jqm.panel.css","e6c3906ecd91b16aa9c7a0d9c243dbbf"],["thirdparty/jquerymobile/jqm.panel.js","53526c171c466e6224c910bb28a6bfd3"],["thirdparty/jquerymobile/jqm.popup.css","5ef1867e54806467a5fdabaf2b09642f"],["thirdparty/jquerymobile/jqm.popup.js","07d66acdc4218482430fb511936e11a8"],["thirdparty/jquerymobile/jqm.widget.js","f6426261d0d01b896d3575e27b9c1f9e"],["thirdparty/jstree/themes/default/32px.png","db49c8de4f267eede40a9a8843efcdec"],["thirdparty/jstree/themes/default/40px.png","1f075735090412ed7eb8077d819b19c6"],["thirdparty/jstree/themes/default/style.css","857b5c3dfc47a645a9027393b7ee78ab"],["thirdparty/jstree/themes/default/style.min.css","60856215964dcfbc157e1c5ec458c7b9"],["thirdparty/jstree/themes/default/throbber.gif","9ed4669f524bec38319be63a2ee4ba26"],["touchicon.png","70410aa992a4f80808fde35a83d93194"],["touchicon114.png","dea7e99e6992ec51e625f06385b9a835"],["touchicon144.png","ec99108bdc911c55feafd8f798a03756"],["touchicon72.png","52ff4823043e0a1333decbba0d8b5725"],["tv.html","69f0da701f6d37d0002de86a768927da"],["useredit.html","a2e0d8abbef4bc316392e7974d0ac346"],["userlibraryaccess.html","f7e18b716a7175d736047d6475379ec7"],["usernew.html","247b38ae987ae17d4ac3bebcd61f8184"],["userparentalcontrol.html","d519bb38134b673d0df7f0e80c8123f7"],["userpassword.html","1d68da4dfc0a3605d544ca5bd67c4045"],["userprofiles.html","f67741588fa52b5cde6287020fe2f9eb"],["videoosd.html","cf17a9456bfc4de45285a5e032a03687"],["wizardagreement.html","7c6448242d5a6eb23e59aae0cc24d20f"],["wizardcomponents.html","c9d86ff6039a00d33c6b251c2f8c07ae"],["wizardfinish.html","a5c398f39cb96477bc04f7d154ef8003"],["wizardlibrary.html","2928de92d75ff98d9f364daec5a61229"],["wizardsettings.html","b2d11bbf1279c754dfba7d53fe7d7cda"],["wizardstart.html","9a8f7d4c468a14278addf5dabc5cda75"],["wizarduser.html","eb40795b0d0bf5a337e17c7ab584cbdb"]];
var cacheName = 'sw-precache-v2-emby-' + (self.registration ? self.registration.scope : '');


var ignoreUrlParametersMatching = [/^v/];



var addDirectoryIndex = function (originalUrl, index) {
    var url = new URL(originalUrl);
    if (url.pathname.slice(-1) === '/') {
      url.pathname += index;
    }
    return url.toString();
  };

var createCacheKey = function (originalUrl, paramName, paramValue,
                           dontCacheBustUrlsMatching) {
    // Create a new URL object to avoid modifying originalUrl.
    var url = new URL(originalUrl);

    // If dontCacheBustUrlsMatching is not set, or if we don't have a match,
    // then add in the extra cache-busting URL parameter.
    if (!dontCacheBustUrlsMatching ||
        !(url.toString().match(dontCacheBustUrlsMatching))) {
      url.search += (url.search ? '&' : '') +
        encodeURIComponent(paramName) + '=' + encodeURIComponent(paramValue);
    }

    return url.toString();
  };

var isPathWhitelisted = function (whitelist, absoluteUrlString) {
    // If the whitelist is empty, then consider all URLs to be whitelisted.
    if (whitelist.length === 0) {
      return true;
    }

    // Otherwise compare each path regex to the path of the URL passed in.
    var path = (new URL(absoluteUrlString)).pathname;
    return whitelist.some(function(whitelistedPathRegex) {
      return path.match(whitelistedPathRegex);
    });
  };

var stripIgnoredUrlParameters = function (originalUrl,
    ignoreUrlParametersMatching) {
    var url = new URL(originalUrl);

    url.search = url.search.slice(1) // Exclude initial '?'
      .split('&') // Split into an array of 'key=value' strings
      .map(function(kv) {
        return kv.split('='); // Split each 'key=value' string into a [key, value] array
      })
      .filter(function(kv) {
        return ignoreUrlParametersMatching.every(function(ignoredRegex) {
          return !ignoredRegex.test(kv[0]); // Return true iff the key doesn't match any of the regexes.
        });
      })
      .map(function(kv) {
        return kv.join('='); // Join each [key, value] array into a 'key=value' string
      })
      .join('&'); // Join the array of 'key=value' strings into a string with '&' in between each

    return url.toString();
  };


var hashParamName = '_sw-precache';
var urlsToCacheKeys = new Map(
  precacheConfig.map(function(item) {
    var relativeUrl = item[0];
    var hash = item[1];
    var absoluteUrl = new URL(relativeUrl, self.location);
    var cacheKey = createCacheKey(absoluteUrl, hashParamName, hash, false);
    return [absoluteUrl.toString(), cacheKey];
  })
);

function setOfCachedUrls(cache) {
  return cache.keys().then(function(requests) {
    return requests.map(function(request) {
      return request.url;
    });
  }).then(function(urls) {
    return new Set(urls);
  });
}

self.addEventListener('install', function(event) {
  event.waitUntil(
    caches.open(cacheName).then(function(cache) {
      return setOfCachedUrls(cache).then(function(cachedUrls) {
        return Promise.all(
          Array.from(urlsToCacheKeys.values()).map(function(cacheKey) {
            // If we don't have a key matching url in the cache already, add it.
            if (!cachedUrls.has(cacheKey)) {
              return cache.add(new Request(cacheKey, {credentials: 'same-origin'}));
            }
          })
        );
      });
    }).then(function() {
      // Force the SW to transition from installing -> active state
      return self.skipWaiting();
    })
  );
});

self.addEventListener('activate', function(event) {
  var setOfExpectedUrls = new Set(urlsToCacheKeys.values());

  event.waitUntil(
    caches.open(cacheName).then(function(cache) {
      return cache.keys().then(function(existingRequests) {
        return Promise.all(
          existingRequests.map(function(existingRequest) {
            if (!setOfExpectedUrls.has(existingRequest.url)) {
              return cache.delete(existingRequest);
            }
          })
        );
      });
    }).then(function() {
      return self.clients.claim();
    })
  );
});


self.addEventListener('fetch', function(event) {
  if (event.request.method === 'GET') {
    // Should we call event.respondWith() inside this fetch event handler?
    // This needs to be determined synchronously, which will give other fetch
    // handlers a chance to handle the request if need be.
    var shouldRespond;

    // First, remove all the ignored parameter and see if we have that URL
    // in our cache. If so, great! shouldRespond will be true.
    var url = stripIgnoredUrlParameters(event.request.url, ignoreUrlParametersMatching);
    shouldRespond = urlsToCacheKeys.has(url);

    // If shouldRespond is false, check again, this time with 'index.html'
    // (or whatever the directoryIndex option is set to) at the end.
    var directoryIndex = 'index.html';
    if (!shouldRespond && directoryIndex) {
      url = addDirectoryIndex(url, directoryIndex);
      shouldRespond = urlsToCacheKeys.has(url);
    }

    // If shouldRespond is still false, check to see if this is a navigation
    // request, and if so, whether the URL matches navigateFallbackWhitelist.
    var navigateFallback = '';
    if (!shouldRespond &&
        navigateFallback &&
        (event.request.mode === 'navigate') &&
        isPathWhitelisted([], event.request.url)) {
      url = new URL(navigateFallback, self.location).toString();
      shouldRespond = urlsToCacheKeys.has(url);
    }

    // If shouldRespond was set to true at any point, then call
    // event.respondWith(), using the appropriate cache key.
    if (shouldRespond) {
      event.respondWith(
        caches.open(cacheName).then(function(cache) {
          return cache.match(urlsToCacheKeys.get(url));
        }).catch(function(e) {
          // Fall back to just fetch()ing the request if some unexpected error
          // prevented the cached response from being valid.
          console.warn('Couldn\'t serve response for "%s" from cache: %O', event.request.url, e);
          return fetch(event.request);
        })
      );
    }
  }
});







importScripts("bower_components/emby-webcomponents/serviceworker/notifications.js","bower_components/emby-webcomponents/serviceworker/sync.js");

